var wall={
	'p':{},						// Posts array
	'c':{},						// Comments array
	'hovered':{},				// Array of currently hovered posts, used to bypass onmouseout that's not working properly
	'newPostLinkType':'text',	// Type of currently selected link type for post being created ('image', 'url', 'map', 'text')
	'view':'board', 			// Type of view: board or classic
	'mapsScriptLoadState':0,	// Set to 1 when loading and 2 when loaded
	'pendingMaps':[],	 		// List of maps waiting to be created when google maps script is loaded
	'selMap':0,					// Map used for new post creation

	// Initialize stuff
	'init':function(){
		winResized();
		if(W.connect){
			connect(D,'mousemove',wall.mouseMove);
			connect(dgi('wallPseudoInput'),'keydown',wall.pseudoInputPopupKD);
		}
	},

	/**
	 * Pseudo random number generator
	 * @param array post: post data, used as salt
	 * @param integer inter: rnd iteration, leave blank to auto-increment
	 * @return float random number (0-1)
	*/
	'rnd':function(post,iter){
		var r=0,i,e;
		if(!post.nbIter) post.nbIter=1; else post.nbIter++;
		if(!iter) iter=post.nbIter;

		if(post.rnd) r=post.rnd;
		else{
	        for(e in post){
                for(i=post[e].length-1;i>=0;i--){
                	r+=post[e].charCodeAt(i)
                }
	        }
	        post.rnd=r;
		}
		while(iter-- > 0){
	        r=(r*r)+' ';
	        while(r.length<5) r='0'+r;
	        r=r.substr(Math.floor(r.length/2-2),4);
	        r=1*r;
		}
		return 1.0*("0."+r);
	},


	// Display type (board/classic)
	'type':'board',
	'setType':function(t){if(t in {'board':1,'classic':1}) wall.type=t},

	// Update all posts + comments data
	'updateData':function(data){
		wall.p=data.posts
		wall.c=data.comments
		// Fix icons paths
		for(var e in wall.p) {
			i=wall.p[e].icon;
			if(i=='facebookIcon.jpg'||i.substr(0,12)=='twitterIcon_') wall.p[e].icon='index.php?wallPostImage='+i; // Facebook and twitter icons
			else wall.p[e].icon=wl.resizedGfx('/gfx/icons/'+wall.p[e].icon,wall.postIconWidth,wall.postIconWidth);
		}
		for(e in wall.c) wall.c[e].icon=wl.resizedGfx('/gfx/icons/'+wall.c[e].icon,wall.commentIconWidth,wall.commentIconWidth);
	},

	// Update all posts and comments
	'updateDisplay':function(){
		var n,h,e,o='';

		for(e in wall.p) o+=wall.postHTML(wall.p[e]);
		if(!o) o+=wall.postHTML(wall.noPostItem);

		dgi('postsArea').innerHTML=o+'<br clear="all">&nbsp;';

		// fix height (I don't remember why)
		if(wall.view!='mobile') for(e in wall.p) {
			n=dgi('p'+wall.p[e].id);
			h=(getElementStyle(n,'height'))
			if(h=='auto') h=n.offsetHeight;
			n.style.height=h+'px';
		}
//		setTimeout(function(){for(e in wall.p) $('p'+wall.p[e].id).e.className().add('aniF2')},10);
	},

	/**
	 * @desc Return HTML code for post item
	 * @param array post: post item
	 */
	'postHTML':function(post){
		var cHTML='',d,e,s,c,link='',pHTML=wall.postTemplate,t,l,nbComments=0;

		d=(typeof(post.link)=='string')?post.link.split(';'):[];
		// Image
		if(post.type=='image') {
			link='<img class="wallPostImage" src="index.php?wallPostImage='+d[3]+'" style="width:'+d[1]+'px;height:'+d[2]+'px">';
		}
		// URL
		if(post.type=='url') {
			if(d[0]=='tn'){
				link='<a class="wallUrl" href="'+d[4]+'" target="_blank">';
				link+='<img class="wallPostImage" src="index.php?wallPostImage='+d[3]+'" style="width:'+d[1]+'px;height:'+d[2]+'px">';
			}
			else
				link='<a class="wallUrl" href="'+d[1]+'" target="_blank">'+d[1];
			link+='</a>';
		}
		// Map
		if(post.type=='map') {
			link='<div class="wallPostMap" id="map'+post.id+'"></div>';
			map=new wallMap('map'+post.id,d[0],d[1],d[2],d[3])
		}
		// Video
		if(post.type=='video') {
			if(d[1]=='youtube')
				link='<iframe type="text/html" width="320" height="192" src="http://www.youtube.com/embed/'+d[0]+'" frameborder="0"  webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
			if(d[1]=='vimeo')
				link='<iframe src="http://player.vimeo.com/video/'+d[0]+'?title=0&amp;byline=0&amp;portrait=0" width="320" height="170" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
			if(d[1]=='dailymotion')
				link='<iframe src="http://www.dailymotion.com/embed/video/'+d[0]+'" width="320" height="180" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
		}

		// Rotation
		s='';
		c='frame2 wallPost';
		if(wall.view=='board'){
			s+='margin:'+wall.postMargins(post)+';';

			a=Math.floor(10*wall.rnd(post)-5);
			c='wallPost board ';
			if(post.type!='map' && post.type!='video') c+='rot'+((a<0)?'m'+(-a):a);

			//post.display=Math.floor(3*wall.rnd(post))
			c+=' type'+post.display+' '+post.type;
		}
		else c+=' type'+post.type;

		// User icon
		if(post.icon) post.icon='<img src="'+post.icon+'" class="wallPostIcon">';

		pHTML=pHTML.replace(/STYLE/,s);
		pHTML=pHTML.replace(/POSTCLASS/,c);
		pHTML=pHTML.replace(/POSTID/g,post.id).replace(/PIN/,'wallPin p'+Math.floor(5*wall.rnd(post)));
		pHTML=pHTML.replace(/TEXT/,post.icon+post.text);
		pHTML=pHTML.replace(/USER/,post.name);
		pHTML=pHTML.replace(/LINK/,link);
		pHTML=pHTML.replace(/CONTROLS/,(post.fake)?'none':'block');

		// New comment form
		pHTML=pHTML.replace(/NEWCOMMENT/,(wall.commentAllowed)?wall.newCommentTemplate.replace(/POSTID/g,post.id):'');

		// Build comments list
		for(e in wall.c) if(wall.c[e].postId==post.id) {
			cHTML+=wall.commentHTML(wall.c[e]);
			nbComments++;
		}
		pHTML=pHTML.replace(/BTCOMMENTSDISPLAY/,(nbComments>0)?'':'visibility:hidden');
		pHTML=pHTML.replace(/NBCOMMENTS/,nbComments);

		pHTML=pHTML.replace(/COMMENTS/,cHTML);

//cfDbgOnce(pHTML)
		return pHTML;
	},

	/**
	 * Compute margins around a post item
	 */
	'postMargins':function(post){
		var w=dgi('postsArea').offsetWidth, h=winMe.getInnerHeight(), pw=wall.postRefWidth, ph, nb=count(wall.p),t,l;

		ph=(post.type=='text')?pw/2:pw;

		if(nb<=1) {
			l=(w-pw)/2;t=(h-ph)/3
			return t+'px '+(w-l-pw)+'px '+(h-t-ph)+'px '+l+'px';
		}
		else if(w/pw>nb){
			bw=(w-pw)/(2*nb);
			bh=(h-ph)/4;
		}
		else{
			bw=pw/(1*Math.sqrt(nb))
			if(2*pw+2*bw>0.9*w) bw=(w-2*pw)/6;
			bh=ph/(1*Math.sqrt(nb))
		}
		if(bw<2) bw=1;
		l=bw*(0.8+0.4*wall.rnd(post,4));
		t=bh*(0.8+0.4*wall.rnd(post,4));
		l=Math.floor(l);
		t=Math.floor(t);

			//alert(t+'px '+Math.floor(bw-l)+'px '+Math.floor(bh-t)+'px '+l+'px')
			return t+'px '+Math.floor(bw-l)+'px '+Math.floor(bh-t)+'px '+l+'px';


	},

	/**
	 * Reset posts margins on new post, post deleted or window resize
	 */
	'recomputePostMargins':function(){
		if(wall.view!='board') return;
		for(e in wall.p) dgi('p'+wall.p[e].id).style.margin=wall.postMargins(wall.p[e])
	},

	/**
	 * Append newly created post
	 * @param post: post data
	 */
	'addNewPost':function(post){
		// Remove "no post" item
		if(dgi('pfake')) $('pfake').e.remove();
		var d=D.createElement('DIV');
		post.icon=wl.resizedGfx('/gfx/icons/'+post.icon,wall.postIconWidth,wall.postIconWidth); // Fix icon
		d.id='postOuter'+post.id;
		d.innerHTML=wall.postHTML(post);
		dgi('postsArea').insertBefore(d,dgi('postsArea').firstChild)
		if(wall.mapsScriptLoadState==2 && post.type=='map') while(wall.pendingMaps.length){wall.pendingMaps.pop().draw()}
		wall.p[post.id]=post; // Add to posts list
		wall.recomputePostMargins()
	},

	/**
	 * Append newly created comment, called by PHP in response to creation
	 * @param comment: post data
	 */
	'addNewComment':function(comment){
		comment.icon='/gfx/icons/'+comment.icon;
		var d=D.createElement('DIV');
		d.id='commentOuter'+comment.id;
		d.innerHTML=wall.commentHTML(comment);
		dgi('comments'+comment.postId).insertBefore(d,dgi('comments'+comment.postId).firstChild)
	},

	/**
	 * HTML code for comment item
	 * @param array comment: comment item
	 */
	'commentHTML':function(comment){
//alert(comment.id+'=>'+comment.text)
		var cClass=(wall.view=='board')?'wallComment':'frame3';
		return wall.commentTemplate.replace(/TXT/,comment.text).replace(/ICON/,comment.icon).replace(/NAME/,comment.name).replace(/DATE/,comment.ts).replace(/ID/g,comment.id).replace(/USER/,comment.name).replace(/CLASS/,cClass);
	},

	/**
	 * Toggle new comment frame display (mobile view)
	 * @param string postId: id of comment's post
	 */
	'toggleNewComment':function(postId){
		var s=dgi('ncd'+postId).style;
		// Show comment line
		if(s.display=='none'){
			s.display='';
			dgi('nc'+postId).focus();
		}
		// Hide comment line
		else s.display='none';
	},

	/**
	 * Toggle new post frame display (mobile view)
	 */
	'toggleNewPost':function(){
		var s=dgi('wallPostForm').style;
		$('wallPostForm').e.showForm(!$('wallPostForm').e.formShown());
	},

	/**
	 * New comment text area key down
	 */
	'newCommentKD':function(postId,e){
		if(!e) e=W.event;
		if(wl.eventKC(e)!=13) return true;
		wall.commentCreate(postId);
	},

	/**
	 * Show/hide post's comments
	 * @param string postId: id of post
	 */
	'toggleComments':function(postId,display){
		var s=dgi('comments'+postId).style;
		s.display=(display||(s.display=='none' && display==undefined))?'':'none';
	},

	/**
	 * Mouse over / out post
	 * @param string id: id of hovered post
	 * @param bool hover: true onmouseover, false onmouseout
	 */
	'postHover':function(id,hover){
		if(wall.view=='mobile') return; // No hover on mobile view
		if(id=='pfake') return; 		// No hover on "no message" item

		if(wall.hovered[id] && hover) return; // Already hovered


		var h=getElementStyle(dgi(id),'height'),w=getElementStyle(dgi(id),'width');
		var mb=getElementStyle(dgi(id),'margin-bottom'),mr=getElementStyle(dgi(id),'margin-right'),ml=getElementStyle(dgi(id),'margin-left');
		if(hover) wall.hovered[id]={'ml':ml,'mr':mr,'mb':mb,'h':''+dgi(id).style.height};

		// Send to back
		if(!hover) {
			$(id).e.className().remove('wallFront');
			var s=dgi(id).style
			// Restore margins & height
			s.marginBottom=wall.hovered[id]['mb']+'px'
			s.marginLeft=wall.hovered[id]['ml']+'px'
			s.marginRight=wall.hovered[id]['mr']+'px'
			s.height=wall.hovered[id]['h'];
		}
		// Bring to front
		else{
			dgi(id).style.height='auto'
			$(id).e.className().add('wallFront');
			// Focus into comments frame but keep current vertical scroll position
			var vPos1,vPos0=D.body.scrollTop; if(!vPos0 && W.pageYOffset) vPos0=W.pageYOffset;
			try{dgi('nc'+id.substr(1)).focus()} catch(e){}
			vPos1=D.body.scrollTop; if(vPos1==undefined) vPos1=W.pageYOffset;
			if(vPos1!=vPos0) W.scrollTo(0,vPos0);
			var nh=getElementStyle(dgi(id),'height'),nw=getElementStyle(dgi(id),'width'),s=dgi(id).style;
			if(nh=='auto') nh=dgi(id).offsetHeight;
			s.marginBottom=(mb*1-nh*1+h*1)+'px'
			s.marginLeft=(ml*1+(-nw*1+w*1)/2)+'px'
			s.marginRight=(mr*1+(-nw*1+w*1)/2)+'px'
		}
	},

	/**
	 * Mouse moved over document: check for posts mouse out
	 */
	'mouseMove':function(){
	    var e,n,p;

	    if(wall.view=='mobile') return; // No hover on mobile view
	    for(e in wall.hovered){
            n=dgi(e);
            if(!n) continue;
            l=n.offsetLeft;t=n.offsetTop;
            if(mouseX<l-20 || mouseX>l+n.offsetWidth+20 || mouseY<t-20 || mouseY>t+n.offsetHeight+20){
            	if((p=dgi('nc'+e.substr(1))) && p.value) continue;
                wall.postHover(e,0)
                delete(wall.hovered[e]);
            }
	    }
	},

	// Delete a post
	'postDelete':function(postId){
		wl.asr.send({'command':'postDelete','id':postId});
		var n=(W.$)?$('p'+postId):dgi('p'+postId)
		if(W.$)	n.e.remove();

		//for(e in wall.p) alert(e+'/'+postId)
		var nb=0;for(e in wall.p) if(e==postId) delete(wall.p[e]); else nb++;
		if(!nb) wall.updateDisplay()
	},

	'commentFocus':function(n){n.style.opacity=1},

	// Create a new comment on a post
	'commentCreate':function(postId){
		if(!dgi('nc'+postId).value) return;
		wall.pseudoInputPopupShow(postId);
	},
	'commentCreateProceed':function(postId){
		wl.asr.send({'command':'commentCreate','text':dgi('nc'+postId).value,'userName':wall.pseudo,'postId':postId});
		dgi('ncd'+postId).style.display='none';
		dgi('nc'+postId).value='';
	},

	// Delete a comment
	'commentDelete':function(id){
		if(wall.view=='mobile') dgi('c'+id).style.display='none'; else $('c'+id).e.verticalFadeInOut(0);
		wl.asr.send({'command':'commentDelete','id':id});
	},

	/**
	 * Submit a new post
	 */
	'sendPost':function(){
		// Check content
		if(!wall.sendPostOk()) return;
		if(wall.view=='mobile') wall.toggleNewPost();
		wall.pseudoInputPopupShow();
	},
	'sendPostProceed':function(){
		var link='';
		if(wall.newPostLinkType=='url') link=dgi('wallNewUrl').value;
		if(wall.newPostLinkType=='video') link=dgi('wallNewVideo').value;
		if(wall.newPostLinkType=='map') {
			var m=wall.selMap.map;
			link=m.getCenter().lat()+';'+m.getCenter().lng()+';'+(Math.floor(1.2*m.getZoom()))+';'+m.mapTypeId;
		}

		// Send request
		if(W.btSetIcon){
			btSetIcon('sendPostBt','/gfx/loading2.gif');
			btDisable('sendPostBt');
		}
		wl.asr.send({'command':'postCreate','text':dgi('wallPostText').value,'userName':wall.pseudo,'type':wall.newPostLinkType,'link':link});

		// Clear and hide form
		dgi('wallPostText').value='';
		wall.linkTypeSelect('text');
		if(wall.view=='mobile') {
			if($('wallPostForm').e.formShown()) wall.toggleNewPost();
			if($('pseudoInputPopup').e.formShown()) $('pseudoInputPopup').e.showForm(0);
		}
		wall.imageUploaded=0;
	},

	// Check all fields are OK for submitting a post
	'sendPostOk':function(){
		var ok=1;
		if(wall.newPostLinkType=='text' && !dgi('wallPostText').value) ok=0;
		if(wall.newPostLinkType=='image' && !wall.imageUploaded) ok=0;
		if(wall.newPostLinkType=='url' && !wall.urlLinkOk()) ok=0;
		if(wall.newPostLinkType=='map' && !wall.mapsScriptLoadState) ok=0;

		try{if(ok) btEnable('sendPostBt'); else btDisable('sendPostBt')} catch(e){}
		return ok;
	},

	/**
	 * Return true if url link is valid
	 */
	'urlLinkOk':function(){
		var regexp = /(http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
		res=regexp.test(dgi('wallNewUrl').value);
		return res;
	},

	// Called as a response to sendPost request, after addNewPost (if success)
	// @param bool ok: true if post was created
	'sendPostCompleted':function(ok){
		btSetIcon('sendPostBt','/gfx/ok16.png');
		wall.linkTypeSelect('text');
	},

	// Select a type of attached link for new post
	// l: 'text', 'image', 'map', 'url'
	'linkTypeSelect':function(l){
		// Chrome double click WA
		if(wl.chrono){
			var mt=wl.chrono.microtime(); if(wall.linkTypeSelectLastMT && (mt-wall.linkTypeSelectLastMT)<100) return; wall.linkTypeSelectLastMT=mt;
		}
		if(wall.newPostLinkType==l) l='text'; // If already selected, set back to text
		wall.newPostLinkType=l;
		var i,n,lt=['image','map','url','video'];
		for(i=0;i<lt.length;i++) if(n=dgi('wallLinkType_'+lt[i])) n.style.display=(l==lt[i])?'block':'none';
		if(l=='map') {
			if(!wall.selMap) wall.selMap=new wallMap(dgi('wallNewMap')); // Create selection map
		}
		if(l=='video') dgi('wallNewVideo').focus();
		if(l=='url'){
			var u=dgi('wallNewUrl');
			u.focus();
			u.selectionStart=u.selectionEnd=u.value.length;
		}
		wall.sendPostOk();
	},

	// Called on completed image upload
	'imageUploadCompleted':function(result){
		wall.imageUploaded=1;
		wall.sendPostOk();
	},


	// Set display interval
	'goMsgs':function(from,to){wl.asr.send({'command':'setInterval','from':from,'to':to})},

	/*
	 * User pseudo management
	 */

	// Show pseudo input popup if necessary or proceed with post or comment submission
	// postId: if user is creating a comment, postId is the id of the post. If user is creating a post, postId is undefined
	'pseudoInputPopupShow':function(postId){
		if(wall.pseudo) return (postId)?wall.commentCreateProceed(postId):wall.sendPostProceed();
		wall.tmpPostId=postId; // Store postId so right function (comments or post) can be called with postId
		if(wall.view=='mobile'){
			$('pseudoInputPopup').e.showForm(1);
		}
		else{
			wl.mask.show(0.7,0);
			if(W.$) $('pseudoInputPopup').e.fadeIn().center(); else dgi('pseudoInputPopup').style.display='';
			dgi('wallPseudoInput').focus();
			wl.mask.moveAbove(dgi('pseudoInputPopup'));
		}
	},
	// Hide pseudo input popup
	'pseudoInputPopupClose':function(){
		if(wall.view=='mobile'){
			$('pseudoInputPopup').e.showForm(0);
		}
		else{
			if(W.fade) fade('pseudoInputPopup',1,0); else dgi('pseudoInputPopup').style.display='none';
			wl.mask.hide()
		}
	},

	// Submit pseudo
	'pseudoInputPopupValidate':function(ok){
		if(!ok){wall.pseudoInputPopupClose();return}
		if(!(wall.pseudo=dgi('wallPseudoInput').value)) return;
		wall.pseudoInputPopupClose();
		return (wall.tmpPostId)?wall.commentCreateProceed(wall.tmpPostId):wall.sendPostProceed();
	},
	'pseudoInputPopupKD':function(e){
		kc=wl.eventKC(e);
		if(kc==13) wall.pseudoInputPopupValidate(1);
		if(kc==27) wall.pseudoInputPopupClose();
	},

	// Load google maps script
	'loadMapScript':function(){
		wall.mapsScriptLoadState=1;
		var script = D.createElement("script");
		script.type = "text/javascript";
		script.src  = "http://maps.googleapis.com/maps/api/js?sensor=false&language="+wall.language+"&callback=wall.mapsScriptLoaded";
		D.getElementsByTagName('head')[0].appendChild(script);
	},
	// google maps script loaded callback: initialize all pending maps
	'mapsScriptLoaded':function(){
		wall.mapsScriptLoadState=2;
		while(wall.pendingMaps.length){wall.pendingMaps.pop().draw()}
	},

	/*
	 * Return default position according to country
	 */
	'defaultMapPosition':function(){
		var c={'fr':[46.558860303,2.7246093,4],'es':[40.01078714046,-4.614257812,5],'pl':[51.9171675890,19.6875,4],'hu':[51.48138289610,11.42578125,4],'pt':[40.44694705960053,-7.14111328125,5],'en':[36.87962060502,-100.65673828125,2],'no':[61.227957176677876,10.43701171875,4],'hu':[47.69497434186287,18.69873046875,5],'ru':[60.694695372877,79.3432617187,2]}
		var co=c[wall.language];
		if(!co) co=c['en'];
		return{'lat':co[0],'lng':co[1],'zoom':co[2]}
	},



	/**
	 * Toggle right frame folding
	 */
	'toggleRightFrameFolding':function(){
		var f=wall.rightFrameFolded;
		f=wall.rightFrameFolded=1-f

		wl.anim({'item':$('wallRightFrameTd'),
			'duration':500,
			'extraParameters':{'startWidth':((f)?dgi('wallRightFrame').offsetWidth:20),'endWidth':((f)?26:dgi('wallRightFrame').offsetWidth+20)},
			'callbackComplete':function(){if(wall.rightFrameFolded) $('wallRightFrameTd').e.className().add('folded'); else $('wallRightFrameTd').e.className().remove('folded')},
			'function':function(p,anim){
				var pe=wl.animFunctionUnfold0(p),s=anim.extraParameters.startWidth, e=anim.extraParameters.endWidth;
				p=Math.floor(s*(1-pe)+e*pe)+'px';
				return {'width':p}
			}
		});
		wl.asr.send({'rightFrameFolded':f});
	},
	'eoc':0
}

/**
 * Google map object
 * @param DOM Node node: node in which map will be built
 * @param number zoom: zoom factor (1 - x)
 * @param number lat: lat  or false to try to center on user
 * @param number lng: long or false to try to center on user
 * @param int zoom: zoom factor
 * @param string: mapType : google map type ('roadmap', 'hybrid', 'satellite')
 */
function wallMap(node,lat,lng,zoom,mapType){
	if(lat==undefined){
		// Try W3C Geolocation (Preferred)
		if(navigator.geolocation) {
			browserSupportFlag = 1;
			navigator.geolocation.getCurrentPosition(
				function(position) {
					lat=position.coords.latitude;
					lng=position.coords.longitude;
					zoom=6;
				},
				function() {

				}
			);
		}
		if(lat==undefined){
			d=wall.defaultMapPosition();
			lat=d.lat;lng=d.lng;
			zoom=d.zoom;
		}
		if(!zoom) zoom=3;
	}
	if(!mapType) mapType='roadmap';
	this.options={
		'lat': lat,
		'lng': lng,
		'zoom': 1.0*zoom,
		'mapType': mapType,
		'node': node
	};
	if(wall.mapsScriptLoadState==2 && (typeof(node) != 'string' || dgi(node))) this.draw(); else wall.pendingMaps.push(this);
	if(!wall.mapsScriptLoadState) wall.loadMapScript();
}

// Create a map
wallMap.prototype.draw=function(){
	var o=this.options;
	if(typeof(o.node)=='string') o.node=dgi(o.node);
	if(o.mapType=='roadmap') o.mapType=google.maps.MapTypeId.ROADMAP;
	else if(o.mapType=='hybrid') o.mapType=google.maps.MapTypeId.HYBRID;
	else o.mapType=google.maps.MapTypeId.SATELLITE;

	var opt={
		zoom:o.zoom,
		center: new google.maps.LatLng(o.lat,o.lng),
		mapTypeId: o.mapType
	};
	this.map = new google.maps.Map(o.node, opt);
}

