<?php
/**
 * Remote desktop configuration file
 *
 * Configuration of administration resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 * this script can only be accessed in "application environment"
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.1.0C
 */

require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');

/*
 ***************************************************************************************************************************
 * Verify access right (complementary of controls realized in security.php
 ***************************************************************************************************************************
 */
$limitedConfig=rcConfigRights(true);

/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();
// Resource icon & name
rcInsertIconName($resourceData);
echo '<br/>';

/**
 * Remote desktop
 */
echo outDivFrame('frame2');

// Description
echo '<br>';
if(!@$_ENV['readOnlyDesktop']) echo cfCaption("administration_rDesk-description");
else echo cfCaption("webcam_remoteDesktop-description");

echo '</div><br>';

echo '<br><br>';

rcAdvancedConfigStart();




/**
 * Quality
 */

echo '<div class="configSubFrameHeader">'.cfCaption('genQuality').'</div>';
echo '<br>';
//echo outImage(outIcon('indicator32'),false,false,'margin-right:0.5em;vertical-align:middle').cfCaption('genQuality');
rcProcessData('quality',dataList,1,array(0,1,2),array(
	array('<fieldset class="blockItem" style="padding:3px;margin:0">'.outImage(outIcon('rabbit32')).outImage(outIcon('qualityLow')),0,'</fieldset>'),
	array('<fieldset class="blockItem" style="padding:3px;margin:0">'.outImage(outIcon('qualityMedium')),1,'</fieldset>'),
	array('<fieldset class="blockItem" style="padding:3px;margin:0">'.outImage(outIcon('qualityHigh')).outImage(outIcon('snail32')),2,'</fieldset>')
	)
);

echo '<br>';
echo '<br>';

/**
 * Auto-adjust
 */
echo '<div class="configSubFrameHeader">'.cfCaption('genSize').'</div>';
echo '<br>';
rcProcessData('adaptZoom',dataBoolean,true,false,array(outImageIcon('rDeskScreenStretch').'&nbsp;&nbsp;'.cfCaption('rDeskAdaptZoom'),outImageIcon('rDeskScreen11').'&nbsp;&nbsp;1:1'));

// End of advanced config panel
rcAdvancedConfigEnd();

// Save / cancel buttons
echo '<br>';
echo rcButtonSaveCancel();

// Default window state
echo rcThemeSelectionControl(false,array('noThemeControl'=>1));



// Extra time given to capture double clicks
rcProcessData('dblClickTime',dataNumeric,600,false,false);
// time of refresh after an event (keyboard or mouse) has been sent to server (in milliseconds)
rcProcessData('refreshAfterEvent',dataNumeric,250,false,false);
// Max refresh time
rcProcessData('refreshAfterNoEvent',dataNumeric,250,false,false);
// Target width & height for squares
rcProcessData('squaresMaxWidth',dataNumeric,256,array(16,2048),false);

if(!$limitedConfig) echo '</div>'; // frame2

// Set default to confirmation required before access is granted to readonly desktop
if(@$_ENV['readOnlyDesktop']) rcProcessData('noHostConfirmation',dataBoolean,false,false,false);


// Allow access to resource directory (data/res/(res type)/(res subType)/(res file name)/)
rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false);

// Show maximized
rcProcessData('maximizeAtFirstCall',dataBoolean,true,false,false);

// If resource need access to resource data dir, create it
rcCreateResourceDataDir();

// Indicate that resource has been initialized
rcProcessData('resourceConfigured',dataBoolean,true,false,false);

// Save parameters
rcWriteResourceFile($resourceData, $fileName);
?>
<script language="javascript" type="text/javascript">
function dataChanged(dataName,dataValue){
	if(dataName=="compression"){
		dgn("jpgQuality").disabled=!(dataValue=='auto'||dataValue=='jpg');
	}
}
function dataInitForm(){dataChangedNV("compression")}
dataInitForm();
</script>