<?php
/**
 * Folder database - based music explorer configuration file
 *
 * Configuration of music explorer resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters loaded from user.res file
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */


$source='files';
require(dirname(__FILE__).'/../music2/config.php');
return;

















/*
 ***************************************************************************************************************************
 * Verify access rights
 ***************************************************************************************************************************
 */
require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
rcConfigRights(false);

//#############################################################################################################
// Process received commands
//#############################################################################################################

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();

// Resource icon & name
rcInsertIconName($resourceData);

echo '<div class="frame2">';
// Base folder
echo '<div class="frame2Header">'.cfCaption('genFiles').'</div>';
$defaultDir=(cfGGetVar('specialFolderMyMusic'))?cfGGetVar('specialFolderMyMusic'):cfAppSharedDir();
rcProcessData('path',dataFolderPath,$defaultDir,false,true);

// Subdirectories included
$_POST['subFoldersIncluded']='true';// Force value to true as disabled checkbox control is treated as a false
rcProcessData('subFoldersIncluded',dataBoolean,true,false,cfCaption('explorerCfgSubDirectoriesIncluded'));
echo '</div>';


/*  Advanced config section
    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/
rcAdvancedConfigStart();

// Download shortcut
rcProcessData('downloadShortcut',dataBoolean,false,false,cfCaption('explorerDownloadShortcut'), false);
echo outHelpButton('helpSDL').'<br/>';

// Multiple download
rcProcessData('multipleDownloadAllowed',dataBoolean,false,false,cfCaption('configAllowMultipleDownload'),false);
echo outHelpButton('helpMD').'<br/>';

echo '<br>';

// Default items per page
rcProcessData('itemsPerPage',dataList,'50',array('10','20','50','100','0'),array(
cfCaption('explorerItemsPerPage'),array(
array('10','10'),
array('20','20'),
array('50','50'),
array('100','100'),
array('0',cfCaption('genAll'))),false), true);
echo '<br>';

// Layout
echo cfCaption('defaultLayout').'&nbsp;&nbsp;&nbsp;&nbsp;';
rcProcessData('displayType',dataList,'displayCovers',array('displayCompact','displayFull','displayCovers'),array(
array(outIcon('displayFile1'),'displayCompact','&nbsp;'),
array(outIcon('displayFull'),'displayFull','&nbsp;'),
array(outIcon('displayIcons'),'displayCovers','&nbsp;')));

// File view (image, audio,...)
rcProcessData('fileViewAllowed',dataBoolean,true,false,false); // Allow/forbid user to listen to audio files

// File access parameters (apply to files and folders located in "path")
rcProcessData('downloadAllowed',dataBoolean,true,false,false/*do not display control*/); // Allow/forbid read access to files and folders
rcProcessData('writeAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/forbid write access to files and folders
rcProcessData('modifyAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/forbid modifcation access to files and folders (need writeAllowed to true)
rcProcessData('executeAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/forbid execute access to files
rcProcessData('uploadAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/forbid file upload
rcProcessData('remoteDownloadAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/forbid remote download of files

rcProcessData('userTempDirAccessAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/forbid access to user temp directory (data/sessiondata/(session_id)/)
rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false/*do not display control*/); // Allow/forbid access to resource directory (data/res/(res type)/(res subType)/(res file name)/)

echo '<div class="frame2">';
// Audio player position
echo '<div class="frame2Header">'.cfCaption('musicCfgMaxBr').'</div>';

// Force inline player
rcProcessData('inlinePlayer',dataBoolean,true,false,false/*do not display control*/);

// Number of songs to put in global library random playlist
rcProcessData('plAddAllShuffleSize',dataNumeric,50,false,false/*do not display control*/);

echo '<br/>';

// Default output bit rate
// Maximum output bit rate
rcProcessData('maxOutputBitRate',dataList,'original',array('original','128','64','32'),array(
array(rcResourceImage('cfgMaxBitrate.png'),cfCaption('musicCfgMaxBr')),array(
array('original',cfCaption('musicCfgNoLimit')),
array('128',cfCaption('explorerAudio128')),
array('64',cfCaption('explorerAudio64')),
array('32',cfCaption('explorerAudio32'))),false), false);
echo outHelpButton('helpAudioMaxBR');
echo '</div>';

rcProcessData('flashPlayerBufferLength',dataNumeric,3,false,false/*do not display control*/); // Default buffer time for flash audio player (seconds)
rcProcessData('flashPlayerDefaultVolume',dataNumeric,70,false,false/*do not display control*/); // Default audio volume for flash audio player (percent)

// Layout
rcProcessData('filesLayout',dataText,'resource',false,false/*do not display control*/); // Default files layout: resource specific */
rcProcessData('filesLayoutLocked',dataBoolean,false,false,false/*do not display control*/); // Do not lock files layout (allow user to change) */

// End of advanced config panel
rcAdvancedConfigEnd();

// Comments panel
echo rcCommentsPanelControl();

// Theme
echo rcThemeSelectionControl();

// Save / cancel buttons
echo '<br/>'.rcButtonSaveCancel();

// If resource need access to resource data dir, create it
rcCreateResourceDataDir();

// Indicate that resource has been initialized
rcProcessData('resourceConfigured',dataBoolean,true,false,false/*do not display control*/);

// Save parameters
rcWriteResourceFile($resourceData, $fileName);
?>
<script language="javascript" type="text/javascript">
function dataInitForm(){dgn('subFoldersIncluded').disabled=true;}
dataInitForm();
</script>