<?php
/**
 * Chat configuration file
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.4
 */

/*
 ***************************************************************************************************************************
 * Verify config rights
 ***************************************************************************************************************************
 */
rcConfigRights();

if(isset($_GET['showLogFile'])){
	$txt=file_get_contents($_ENV['resourceDirectory'].'/chat.txt');
	$txt=cfUTF8Encode($txt);
	$txt=str_replace("\n",'<br>',$txt);
	die($txt);
}

/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();


// Resource icon & name
rcInsertIconName($resourceData);

echo outDivFrame('frame2');
echo '<div class="frame2Header">'.cfCaption('resWebcamStd').'</div>';
rcProcessData('webcam', dataBoolean, false, false, cfCaption('chatEnableWebcams'));// Display users webcam
rcProcessData('webcamWidth', dataNumeric, 320, false, false); // Webcam default width, do not display
rcProcessData('webcamHeight', dataNumeric, 200, false, false); // Webcam default height, do not display
echo '</div>';

/*  Advanced config section
vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/
rcAdvancedConfigStart();

// Show messages posted before user's connection
rcProcessData('showPreviousMessages',dataBoolean, true, false, cfCaption('chatShowPrevious'),false);
echo '<br/>';
// Emit a sound on server when an user connects
rcProcessData('connectionNotification',dataBoolean, true, false, cfCaption('chatVisualNotification'));
echo '<br/>';
// Emit a sound on server when an user types a message
rcProcessData('messageNotification',dataBoolean, true, false, cfCaption('chatAudioNotification'));
echo '<br/>';


// Chat refresh rate
rcProcessData('refreshMs',dataNumeric, 1500, array(100,20000), array(cfCaption('genRefreshRateMS'),4));
echo '<br/>';

// Save exchanges to file
rcProcessData('dumpToFile',dataBoolean, true, false, cfCaption('chatDumpToFile'),false);

// View file button
echo outBt(cfCaption('genOpen'),false,'javascript:var url=W.location.href;url+=((url.indexOf(\'?\')!=-1)?\'&\':\'?\')+\'showLogFile=1\';wl.popup(url,\'Log\',{\'width\':500,\'height\':600})',false,false,'target="_blank"');
echo '<br/><br/><br/>';

// Force chat window to open when remote administrator opens chat
rcProcessData('forceOpen',dataBoolean,true,false,false); /* Do not display control */

// Resource theme
echo rcThemeSelectionControl(false,array('noWindowSizeControl'=>1));

// Save / cancel buttons
echo '<br/>'.rcButtonSaveCancel();

// Allow access to resource directory (data/res/(res type)/(res subType)/(res file name)/)
rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false/*do not display control*/);

// If resource need access to resource data dir, create it
rcCreateResourceDataDir();
if(!file_exists($_ENV['resourceDirectory'].'/chat.txt')) cfAppendTextToFile(cfCaption('genChat'),$_ENV['resourceDirectory'].'/chat.txt');

// Indicate that resource has been initialized
rcProcessData('resourceConfigured',dataBoolean,true,false,false/*do not display control*/);

// Save parameters
rcWriteResourceFile($resourceData, $fileName);
?>