<?php

/**
 * @return string : HTML code
 * @param string $themeLevel : 'general', 'user', 'resource'
 * @param boolead $targetParentFrame : true if form is submited in parent frame (/index.php)
 * @desc return HTML code for theme selection for given level, through included POST form
*/
function themeSelectionControl($theme){
	$dir=cfAppDocRoot().'/themes';
	// Form
	$output= '<form action="themePreview.php" target="_parent" method="GET" enctype="multipart/form-data" name="themeForm" style="display:inline"'.">\n";

	// icon
	$output .= outImage(outIcon('theme'),false, false,'margin-right:0.5em;vertical-align:bottom');
	// Label
	$output .= '<span style="margin-right:1em;">'.cfCaption('genTheme').'</span>';
	$themes=cfMGetVar('weezoThemes');
	// Select
	$output .= '<select class="smallFont" name="theme" id="themeSelect" size="1" onChange="document.themeForm.submit()">';

	foreach ($themes as $key=>$value) if(!isset($value['private'])){
		if($key==$theme) $output .= '<option selected value="'.cfUTF8Encode($key).'">'.cfUTF8Encode($key).'</option>';
		else $output .= '<option value="'.cfUTF8Encode($key).'">'.cfUTF8Encode($key).'</option>';
	}
	$output .= '</select>';
	$output.='</form>';
	return $output;
}

if(!isset($_GET['theme'])) exit;

	require(INCLUDE_DIR.'outputFunctions.php');

	echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'."\n";
	echo '<HTML><HEAD>'."\n";
	// No cache
	//echo '<meta http-equiv="expires" content="0">'."\n";
	// Charset
	echo '<meta http-equiv="content-type" content="text/html; charset=utf-8">'."\n";
	// Title
	echo '<TITLE>'.$_GET['theme'].'</TITLE>'."\n";
	// Load theme :
	echo '<link rel="stylesheet" type="text/css" href="'.cfUTF8Encode("/themes/".$_GET['theme'].'/theme.css')."\">\n";
	// Load describer.ini information
	$author=false; $authorURL=false;
	if(file_exists(cfAppDocRoot().'/themes/'.$_GET['theme'].'/describer.ini')){
		$describerData=cfParse_ini_file(cfAppDocRoot().'/themes/'.$_GET['theme'].'/describer.ini');
		if(isset($describerData['author'])) $author=$describerData['author'];
		if(isset($describerData['authorURL'])) $authorURL=$describerData['authorURL'];
	}
	// javascript
	echo cfScriptLink('common.js');
	echo '</head><body>';
	$gr=outButton("Button",'#',outIcon('logoSmall'),'toolTip');
	$tx=outButton("Button",'#',false,'toolTip');

	// Shadowed frame1
	outShadowBefore("100%");
	echo outDivFrame('frame1');
	echo outFrameHeaderTable('frame1Header',$gr.$_GET['theme'].' theme',$tx);
	if($author) echo '<b>Author: '.cfUTF8Encode($author).'</b><br>';
	if($authorURL) echo outButton(cfUTF8Encode($authorURL),$authorURL).'<br>';
	echo 'This is a sample page for '.$_GET['theme'].' theme'.outButton('Button',false,false,false,false,'style="margin-left:1em"').'<br>';


	// frame2
	echo outDivFrame('frame2');
	echo outFrameHeaderTable('frame2Header','2',$tx);
	echo 'This is a sample page for '.$_GET['theme'].' theme'.outButton('Button',false,false,false,false,'style="margin-left:1em"').'<br>';
	// frame3
	echo outDivFrame('frame3');
	echo outFrameHeaderTable('frame3Header','3',$tx);
	echo 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. '.outButton('Button',false,false,false,false,'style="margin-left:1em"').'<br>';	echo outFrameFooterTable('frame3Footer',$gr.$_GET['theme'],$tx);
	echo '</div>';

	// frame3
	echo outDivFrame('frame3');
	echo outFrameHeaderTable('frame3Header','3',$tx);
	echo 'This is a sample page for '.$_GET['theme'].' theme'.outButton('Button',false,false,false,false,'style="margin-left:1em"').'<br>';
	echo ' Donec dolor. Praesent non sapien. Suspendisse ac urna. Integer eget mi. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec ultricies. Etiam volutpat eleifend enim. Mauris at quam. Phasellus lacinia.';
	echo '</div>';
	// ETC table
	echo outTableTransparent('frame1',false,'cellspacing="20"');
	for($i=1;$i<6;$i++){
		$del='td';
		echo '<tr class="eTC'.(($i%2)?' even':'').'" eH=1 id="t'.$i.'"><'.$del.' class="eTCLeft" style="text-align:left">'.outImage(outIcon('add'), false,false,'vertical-align:middle; padding:2px; margin-right:1em').'</'.$del.'><'.$del.'>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. </'.$del.'><'.$del.' class="eTCRight" style="text-align:right">Lorem ipsum dolor sit amet, consectetuer adipiscing elit. </'.$del.'></tr>';
	}
	echo '</table><br/>';

	echo outFrameFooterTable('frame2Footer','2',$tx);
	echo '</div>';

	echo outFrameFooterTable('frame1Footer','1',$tx);
	echo '</div>';
	outFrameShadowAfter();

	echo '<br>';

	$_SESSION['lng']['genTheme']="Theme";
	echo themeSelectionControl($_GET['theme']);
?>
